<?php
/*
Plugin name: پلاگین مدیریت دیدار
version: 1.4.2
Description: پلاگین اتصال به api دیدار
*/

use Automattic\WooCommerce\Utilities\OrderUtil;

function isHPOSenabled(){
	if (OrderUtil::custom_orders_table_usage_is_enabled()) {
		return true;
	} else {
		return false;
	}
}

if(!defined('ds'))
	define('ds',DIRECTORY_SEPARATOR);
define('did_path',dirname(__file__).ds);

include_once(did_path.'inc'.ds.'helper.php');
include_once(did_path.'inc'.ds.'hooks.php');
include_once(did_path.'inc'.ds.'didar_api.php');
include_once(did_path.'inc'.ds.'paging.php');

new did_hooks();


function did_enqueue_admin_css_for_wc_orders() {
	//$screen = get_current_screen();
	//if ($screen && $screen->id === 'woocommerce_page_wc-orders') {
	wp_enqueue_style('didar-admin-css', plugins_url( 'assets/css/admin.css', __FILE__ ) );
	//}
}
add_action('admin_enqueue_scripts', 'did_enqueue_admin_css_for_wc_orders');

add_action( 'admin_enqueue_scripts', 'did_plugin_enqueue_scripts' );
function did_plugin_enqueue_scripts() {
	wp_enqueue_style( 'did-plugin-style', plugins_url( 'css/style.css', __FILE__ ), array(), '1.0' );
	$inline_css = "
#toplevel_page_did_managment img {
    width: 20px;
    height: auto;
}
    ";
	wp_add_inline_style( 'did-plugin-style', $inline_css );
}

add_action( 'add_meta_boxes', 'did_custom_order_meta_box' );
/**
 * Add custom meta box.
 *
 * @return void
 */
function did_custom_order_meta_box() {

	add_meta_box(
		'custom-order-meta-box',
		'دیدار',
		'did_custom_order_meta_box_callback',
		wc_get_page_screen_id( 'shop-order' ),
		'side',
		'core'
	);
}

function did_custom_order_meta_box_callback( $post ){
	$order = wc_get_order($post->ID);
	$opt = get_option( 'did_option', [] );
?>
<div class="order_data_column">
	<?php if(in_array('wc-'.$order->get_status(),$opt['status'])){ ?>
	<div class="didar_status">
		<?php
		if($code=get_post_meta($order->get_id(),'didar_id',true))
			echo "<span class='sent'>ارسال شده</span>
			<div>کد ثبت شده:<kbd class='dcode'>".get_post_meta($order->get_id(),'didar_id',true)."</kbd></div>";
		else
			echo "<span class='waiting'>ارسال نشده</span>";
		?>
	</div>
	<div class="save_order_didar_wrapper">
		<input type="checkbox" name="didar" value="1"/> <label>ارسال به دیدار</label>
	</div>
	<?php
	}else 
		echo 'فاکتور جاری اماده برای ارسال نمیباشد.';
	?>
</div>
<?php
}

add_action('woocommerce_process_shop_order_meta', 'did_save_admin_order', 10, 2);
function did_save_admin_order($order_id, $order){

	if(!is_admin() or !isset($_POST['didar']))
		return;
	$didar = didar_api::save_order($order_id);

	if(isset($didar->Message) or isset($didar->Error))
		update_post_meta($order_id,'didar_msg',(isset($didar->Message)?ucfirst(strip_tags($didar->Message) ) . " [" . $didar->Code . "]" :ucfirst(strip_tags($didar->Error) )));
	else
		update_post_meta($order_id,'didar_id',$didar->Id);

}
/*function custom_order_meta_box_callback( $order ) {
?>
		<div class="order_data_column">
			<div class="didar_status">
			<?php
			if($order->get_status()!='completed')
				echo 'فقط فاکتورهای تکمیل شده قابل ارسال میباشند';
			else{
				if($code=get_post_meta($order->get_id(),'didar_id',true)){
					echo "<span class='sent'>ارسال شده</span>
					<p style='margin-bottom: 5px;''>کد ثبت شده:</p>
					<code class='dcode'>$code</code>
					";

				$btn = isset($code)?'ثبت دوباره':'ثبت فاکتور در دیدار';
?>
				<div class="save_order_didar_wrapper"><input type="button" value="<?php echo $btn ?>" class="button-primary save_order_didar"></div>
				<script>
				jQuery('.save_order_didar').click(function(){
					jQuery('.save_order_didar_wrapper').addClass('wait');
					jQuery('.msg').hide();
					jQuery.ajax({
						url:ajaxurl,
						type:'POST',
						data:{
							action:'didar_send_order',
							oid:<?php echo $order->get_id(); ?>
						},
					}).done(function(data) {
						jQuery('.msg').text(data[1]).show();
						jQuery('.save_order_didar_wrapper').removeClass('wait');
					});
				});
				</script>
				<?php
				}else{
					echo "<span class=''>ارسال نشده</span>";
				}
			}
?>
			</div>
			<span class="msg notice" class="respond" style="display:none"></span>
</div>
<?php
}*/

function did_get_sku($pid) {
	return get_post_meta( $pid, "_sku", true);

	/*$product = wc_get_product($variation_id);

    if ($product && $product->is_type('variation')) {
        $parent_id = $product->get_parent_id();
        $parent_product = wc_get_product($parent_id);

        if ($parent_product) {
            $variations = $parent_product->get_available_variations();

            foreach ($variations as $variation) {
                if ($variation['variation_id'] === $variation_id) {
                    return $variation['sku'];
                }
            }
        }
    }

    return '';*/
}


function did_get_variation_id_by_sku($sku) {
	global $wpdb;

	$variation_id = $wpdb->get_var(
		$wpdb->prepare(
			"SELECT p.ID
            FROM {$wpdb->prefix}posts p
            INNER JOIN {$wpdb->prefix}postmeta pm ON p.ID = pm.post_id
            WHERE p.post_type = 'product_variation'
            AND p.post_status = 'publish'
            AND pm.meta_key = '_sku'
            AND pm.meta_value = %s",
			$sku
		)
	);

	return $variation_id;
}


/**
* schedular task
*/
// Schedule the function to run hourly
add_action('didar_send_all_order_cron', 'didar_send_all_order_function');
function didar_send_all_order_function() {
	global $wpdb;
	$opt    = get_option( 'did_option', [] );

	if( $opt['send_type'] == 1){

		$from = isset($opt['order_start'])?$opt['order_start']:0;
		$to   = isset($opt['order_count'])?$opt['order_count']:20;
		$status = implode("','",$opt['status']);

		if( isHPOSenabled() ){

			$rows = $wpdb->get_results("
		select * from {$wpdb->prefix}wc_orders o 
		where o.type='shop_order' and o.status in('$status') 
		and o.id> $from and NOT EXISTS(select post_id from $wpdb->postmeta where post_id=o.id and meta_key='didar_id' and meta_value<>'') 
		order by id limit $to", ARRAY_A);

			if(!empty($rows)){
				foreach($rows as $row){
					$didar = didar_api::save_order($row['id']);
					if(isset($didar->Message)or isset($didar->Error)){
						update_post_meta($row['id'],'didar_msg',(isset($didar->Message)?$didar->Message:$didar->Error));
					}
					if(isset($didar->Id)){
						update_post_meta($row['id'],'didar_id',$didar->Id);
					}

				}
			}

		}else{

			$rows = $wpdb->get_results("
		select * from {$wpdb->prefix}posts o 
		where o.post_type='shop_order' and o.post_status in('$status') 
		and o.ID> $from and NOT EXISTS(select post_id from $wpdb->postmeta where post_id=o.ID and meta_key='didar_id' and meta_value<>'') 
		order by ID limit $to", ARRAY_A);

			if(!empty($rows)){
				foreach($rows as $row){
					$didar = didar_api::save_order($row['ID']);
					if(isset($didar->Message)or isset($didar->Error)){
						update_post_meta($row['ID'],'didar_msg',(isset($didar->Message)?$didar->Message:$didar->Error));
					}
					if(isset($didar->Id)){
						update_post_meta($row['ID'],'didar_id',$didar->Id);
					}

				}
			}

		}


	}

}



// Schedule the cron event on plugin activation
register_activation_hook(__FILE__, 'didar_send_all_order_schedule_cron');
function didar_send_all_order_schedule_cron() {
	if (!wp_next_scheduled('didar_send_all_order_cron')) {
		wp_schedule_event(time(), 'hourly', 'didar_send_all_order_cron');
	}
}

// Remove the cron event on plugin deactivation
register_deactivation_hook(__FILE__, 'didar_send_all_order_remove_cron');
function didar_send_all_order_remove_cron() {
	wp_clear_scheduled_hook('didar_send_all_order_cron');
}
