<?php
class didar_api{


	private static function send_request($router,$params=[]){

		$opt = get_option( 'did_option', [] );
		$ch  = curl_init("https://app.didar.me/api/$router?apikey={$opt['didar_api']}");
		curl_setopt( $ch, CURLOPT_POST, 1);
		curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, 0);
		curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt( $ch, CURLOPT_SSL_VERIFYHOST, 0);
		curl_setopt( $ch, CURLOPT_POSTFIELDS, json_encode($params,JSON_UNESCAPED_UNICODE));
		curl_setopt( $ch, CURLOPT_HTTPHEADER, array('Content-Type:application/json'));
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
		$resp = curl_exec($ch);
		return json_decode($resp);
	}


	public static function get_kariz_list(){
		return self::send_request('pipeline/list/0',[])->Response;
	}

	public static function get_user_list(){
		return self::send_request('User/List',[])->Response;
	}


	private static function get_price($product_id){
		if($price = get_post_meta($product_id,'_sale_price',true))
			return $price;
		if($price = get_post_meta($product_id,'_regular_price',true))
			return $price;
		if($price = get_post_meta($product_id,'_price',true))
			return $price;
	}

	public static function has_user($mobile){

		$user = self::send_request('contact/getbyphonenumber',['MobilePhone'=>$mobile])->Response;
		return empty($user)?false:$user[0];
		/*$user = self::send_request('contact/personsearch',['Criteria'=>['LeadType'=>3,'Keywords'=>$user_name]])->Response;
        if($user->TotalCount==0)
        return false;
        else
        return $user->List[0];*/
	}


	public static function create_user($args=[]){
		if($user = self::has_user($args['MobilePhone']))
			return $user;
		$resp = self::send_request('contact/save',['Contact'=>$args]);
        return isset($resp->Response)?$resp->Response:$resp;
	}

	public static function has_product($pid){
		return self::send_request('product/search',['Criteria'=>['Query'=>urlencode($pid)]]);
	}

	public static function get_product_by_code($id){
		global $wpdb;
		$sku = get_post_meta($id,'_sku',true);
		//$parent = $wpdb->get_var("select post_parent from $wpdb->posts join $wpdb->postmeta on ID=post_id and meta_key='_sku' and meta_value='$sku'");
		$parent = $wpdb->get_var("select post_parent from $wpdb->posts where ID=$id");
		$idx     = empty($parent)?$sku:get_post_meta($parent,'_sku',true);
		$product = self::send_request('product/getproductbycodes',['Code'=>[$idx]])->Response->Products[0];

		if(empty($product))
			return;
		if(empty($parent))
			return $product;
		foreach($product->Variants as $Variants){
			if($Variants->VariantCode == $sku)
				return $Variants;
		}
		//return self::send_request('product/getproductbycodes',['Code'=>[$idx]])->Response->Products;
	}

	public static function create_product($item){

		global $wpdb;
		$id = empty($item->get_variation_id())?$item->get_product_id():$item->get_variation_id();
		$product = self::get_product_by_code($id);
		if(!empty($product)){
			update_post_meta( $id, 'didar_id', $product->Id );
			return empty($product->ProductId)?[$product->Id,null]:[$product->ProductId,$product->Id];
		}

		/*if($product = get_post_meta( $item->get_product_id(), 'didar_id', true )){
			if($variant = get_post_meta( $item->get_variation_id(), 'didar_id', true ))
				return [$product,$variant];
			else if(empty($item->get_variation_id()))
				return [$product,null];
		}*/


		$title = get_the_title($item->get_product_id());
		$args  = [
			'Title'             => $title,
			'Code'              => did_get_sku($item->get_product_id()),//$item->get_product_id(),
			'Unit'              => 'IRR',
			'Description'       => '',
			'TitleForInvoice'   => $title,
			'ProductCategoryId' => '313180cb-29c4-45ec-918c-aecc3229c3af',
			'Variants'          => []
		];
		if(empty($item->get_variation_id())){
			$args['UnitPrice']=$item->get_subtotal();
			if(get_option('woocommerce_currency')=='IRT')
				$args['UnitPrice']*= 10;
		}



		if($didar = get_post_meta( $item->get_product_id(), 'didar_id', true )){
			$args['Id'] = $didar;
		}


		$variations = $wpdb->get_results("select * from $wpdb->posts where post_type='product_variation' and post_status='publish' and post_parent=".$item->get_product_id());
		if(!empty($variations)){

			foreach($variations as $i=>$variation){
				$price = self::get_price($variation->ID);
				if(get_option('woocommerce_currency')=='IRT')
					$price*= 10;

				$args['Variants'][$i] = [
					'UnitPrice'       => $price,
					'Title'           => $variation->post_title,
					'VariantCode'     => did_get_sku($variation->ID),
					'TitleForInvoice' => $variation->post_title,
					'IsDefault'       => false
				];
				if($didid = get_post_meta( $variation->ID, 'didar_id', true )){
					$args['Variants'][$i]['Id']        = $didid;
					$args['Variants'][$i]['ProductId'] = $didar;
				}
			}
		}

		$product = self::send_request('product/save',['Product'=>$args]);

		if(!isset($product->Response))
			return $product;
		$product = $product->Response;

		if(isset($product->Id))
			update_post_meta($item->get_product_id(), 'didar_id',$product->Id);
		if(!empty($product->Variants)){
			foreach($product->Variants as $variant){
				update_post_meta(did_get_variation_id_by_sku($variant->VariantCode), 'didar_id',$variant->Id);
				//update_post_meta($variant->VariantCode, 'didar_id',$variant->Id);
			}
		}
		$var_id = empty($item->get_variation_id())?null:get_post_meta( $item->get_variation_id(), 'didar_id', true );
		return [get_post_meta( $item->get_product_id(), 'didar_id', true ),$var_id];
	}

	public static function get_category(){
		return self::send_request('product/categories',[])->Response;
	}

	public static function create_order($args=[]){

		return self::send_request('deal/save',$args);
	}

	public static function save_order($order_id){
		
        $opt   = get_option( 'did_option', [] );
		$order = new WC_Order($order_id);
		$args = [
			'Type'=>'Person',
			'FirstName'      => $order->get_billing_first_name(),
			'LastName'       => $order->get_billing_last_name(),
			'DisplayName'    => $order->get_formatted_billing_full_name(),
			'MobilePhone'    => $order->get_billing_phone(),
			'Email'          => $order->get_billing_email(),
			'IsCustomer'     => true,
			//'CustomerCode' => $order->get_customer_id(),
			'ZipCode'        => $order->get_billing_postcode(),
			'CityTitle'      => $order->get_billing_city(),
			'ProvinceTitle'  => $order->get_billing_state(),
			'CompanyName'    => $order->get_billing_company(),
			'VisibilityType' => 'All',
			'Addresses'      => ['KeyValues'=>[
				[
					'Key'   => "آدرس",
					'Value' => preg_replace("/<[^>]+>/is"," ",$order->get_formatted_billing_address()),
				],
			]],
		];
		$user = self::create_user($args);
        if(!isset($user->Id))
            return $user;

		$product = [];
		$items   = $order->get_items();
		foreach ( $items as $item ) {
			$did_prod = self::create_product($item);
            if(is_object($did_prod))
                return $did_prod;
			

			$price = intval($item->get_subtotal()/$item->get_quantity());
			if(get_option('woocommerce_currency')=='IRT')
				$price*= 10;

			$product[] = [
				'ProductId'   => $did_prod[0],
				'Quantity'    => $item->get_quantity(),
				'UnitPrice'   => $price,
				'Discount'    => $item->get_subtotal_tax(),
				'ProductCode' => (empty($item->get_variation_id())?did_get_sku($item->get_product_id()):did_get_sku($item->get_variation_id()) ),
				//'ProductCode' => (empty($item->get_variation_id())?$item->get_product_id():$item->get_variation_id()),
				'VariantId'   => $did_prod[1]
			];
		}
		$tax  = empty($order->get_total_tax())?0:($order->get_total_tax()/$order->get_total()*100);
		$status = 0;
		switch($order->get_status()){
			case 'completed':$status=1;break;
			case 'cancelled':
			case 'refunded':
			case 'failed':$status=2;break;
			default:$status=0;break;
		}
		if(get_option('woocommerce_currency')=='IRT'){
			$price= $order->get_total()*10;
			$tax *= 10;
		}else
			$price=$order->get_total();
		$soid = isset($opt['soid']) and $opt['soid']=='on'?' '.$order->get_order_number():'';
		$args = [
			'PersonId'        => $user->Id,
			'ContactId'       => $user->Id,
			'Status'          => $status,
			'Title'           => 'معامله '.$order->get_formatted_billing_full_name().$soid,
			'Price'           => $price,
			'Code'            => $order_id,
			'TaxPercent'      => $tax,
			//'RegisterDate'  => $order->get_date_created(),
			'IsPaid'          => true,
			'IsWon'           => ($status==1?true:false),
			'OwnerId'         => $opt['user'],
			'PipelineStageId' => (isset($opt['kariz'])?$opt['kariz']:''),
		];
		
		//echo(json_encode(['Deal'=>$args,'DealItems'=>$product]));die;
		$out = self::create_order(['Deal'=>$args,'DealItems'=>$product]);
		//var_dump(['Deal'=>$args,'DealItems'=>$product]);
		//var_dump($out);
		return isset($out->Response)?$out->Response:$out;
	}
}